#ifndef _BUILTIN_H_
#define _BUILTIN_H_
#include "plat_types.h"

//Builtin Types
enum {
	TYPE_UINT8 = 1,
	TYPE_UINT16,
	TYPE_UINT32,
	TYPE_UINT64,
	TYPE_INT8,
	TYPE_INT16,
	TYPE_INT32,
	TYPE_INT64,
	TYPE_FLOAT32,
	TYPE_FLOAT64,
	TYPE_ARRAY,
	TYPE_METHODMISSINGEXCEPTION,
	TYPE_FIELDMISSINGEXCEPTION,
	TYPE_WRONGTYPEEXCEPTION,
	TYPE_FIRST_USER //Insert new builtin types before this one
};

//Builtin Methods
enum {
	METHOD_SETFIELDMISSING=1,
	METHOD_GETFIELDMISSING,
	METHOD_ADD,
	METHOD_SUB,
	METHOD_DIV,
	METHOD_MUL,
	METHOD_LSHIFT,
	METHOD_RSHIFT,
	METHOD_EQUALS,
	METHOD_GREATER,
	METHOD_LESS,
	METHOD_MISSING,//Insert new builtin methods before this one
	METHOD_FIRST_USER 
};

void register_builtin_types();
void register_builtin_type(uint32_t type);

#endif //_BUILTIN_H_
